/*
 *  Copyright (C) 1997, 1998 Olivetti & Oracle Research Laboratory
 *
 *  This is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This software is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this software; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
 *  USA.
 *
 *  Seriously modified by Fredrik Hbinette <hubbe@hubbe.net>
 */

/*
 * x2vnc - control VNC displays without showing them
 */

#include <x2vnc.h>
#include <time.h>
#include <stdlib.h>

int targetx = 100;
int targety = 100;
int curx = 1;
int cury = 1;

void MoveToTarget() {
	int dx;
	int dy;

	if (curx == targetx && cury == targety) {
		targetx = rand() % 640;
		targety = rand() % 480;
	}
		
	dx = (targetx - curx);
	dy = (targety - cury);

	if (dx > 0) dx = dx/35 + 1;
	if (dx < 0) dx = dx/35 - 1;
	if (dy > 0) dy = dy/35 + 1;
	if (dy < 0) dy = dy/35 - 1;

	curx += dx;
	cury += dy;

	/* printf("cur (%d, %d) targ (%d, %d) delt (%d, %d)\n",
	   curx, cury, targetx, targety, dx, dy); */
	
	SendPointerEvent(curx, cury, 0);
}
	

	
int
main(int argc, char **argv)
{
    fd_set fds;
    struct timeval tv, *tvp;
    int msWait;

    srand(time(NULL));
    
    processArgs(argc, argv);

    if (!ConnectToRFBServer(hostname, port)) exit(1);
    if (!InitialiseRFBConnection(rfbsock)) exit(1);

    if (!SetFormatAndEncodings()) {
	exit(1);
    }


    while (1)
    {

	    MoveToTarget();
	    
	tv.tv_sec = 0;
	tv.tv_usec = 250;

	FD_ZERO(&fds);
	FD_SET(rfbsock,&fds);

	if (select(FD_SETSIZE, &fds, NULL, NULL, &tv) < 0) {
	    exit(1);
	}

	if (FD_ISSET(rfbsock, &fds)) {
	    if (!HandleRFBServerMessage()) {
		exit(1);
	    }
	}
    }

    return 0;
}
